unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Printers;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure Draw(in_Canvas:TCanvas;in_R:TRect;in_ScaleX:Real=1;in_ScaleY:Real=1);
var
  TS:TTextStyle;

begin
  TS.SingleLine:=False;
  TS.Clipping:=True;
  TS.ExpandTabs:=False;
  TS.ShowPrefix:=False;
  TS.Wordbreak:=False;
  TS.Opaque:=False;
  TS.SystemFont:=False;
  TS.RightToLeft:=False;
  TS.EndEllipsis:=False;

  in_R:=Rect(in_R.Left,Round(in_R.Top*in_ScaleX),Round(in_R.Right*in_ScaleX),Round(in_R.Bottom*in_ScaleX));

  in_Canvas.Brush.Color:=clGray;

  in_Canvas.Font.Name:='Open Sans';
  in_Canvas.Font.Size:=10;
  in_Canvas.Font.Color:=clYellow;

  in_Canvas.FillRect(in_R);
  in_Canvas.TextRect(in_R,0,0,'1234567890123456789',TS);

  in_Canvas.Pen.Color:=clRed;
  in_Canvas.Frame(in_R);
end;

const
  W=140;
  H=20;
  S_DPI_X=96;
  S_DPI_Y=96;
  P_DPI_X=600;
  P_DPI_Y=600;


procedure TForm1.FormPaint(Sender: TObject);
var
  R:TRect;

  B:TBitmap;

begin
  R:=Rect(0,0,W,H);
  Draw(Canvas,R);

  R:=Rect(0,50,W,H+50);
  R.Right:=Round(R.Right-((P_DPI_X/S_DPI_X)*R.Right/100));
  Draw(Canvas,R);

  B:=TBitmap.Create;
  B.SetSize(R.Right,H);
  Draw(B.Canvas,Rect(0,0,B.Width,B.Height));
  Canvas.StretchDraw(Rect(0,100,W,H+100),B);
  B.Free;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Printer.BeginDoc;
  Draw(Printer.Canvas,Rect(0,0,W,H),P_DPI_X/S_DPI_X,P_DPI_Y/S_DPI_Y);
  Printer.EndDoc;
end;

end.
